
From: Benjamin Herrenschmidt <benh@kernel.crashing.org>

This is the ppc32 patch equivalent to the just posted ppc64 one working
around a bug in Apple device-trees regarding the "cpus" nodes.

Signed-off-by: Benjamin Herrenschmidt <benh@kernel.crashing.org>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 arch/ppc/syslib/prom_init.c |   10 ++++++++++
 1 files changed, 10 insertions(+)

diff -puN arch/ppc/syslib/prom_init.c~ppc32-apple-device-tree-bug-fix arch/ppc/syslib/prom_init.c
--- 25/arch/ppc/syslib/prom_init.c~ppc32-apple-device-tree-bug-fix	2005-06-01 00:22:11.000000000 -0700
+++ 25-akpm/arch/ppc/syslib/prom_init.c	2005-06-01 00:22:11.000000000 -0700
@@ -626,8 +626,18 @@ inspect_node(phandle node, struct device
 	l = call_prom("package-to-path", 3, 1, node,
 		      mem_start, mem_end - mem_start);
 	if (l >= 0) {
+		char *p, *ep;
+
 		np->full_name = PTRUNRELOC((char *) mem_start);
 		*(char *)(mem_start + l) = 0;
+		/* Fixup an Apple bug where they have bogus \0 chars in the
+		 * middle of the path in some properties
+		 */
+		for (p = (char *)mem_start, ep = p + l; p < ep; p++)
+			if ((*p) == '\0') {
+				memmove(p, p+1, ep - p);
+				ep--;
+			}
 		mem_start = ALIGNUL(mem_start + l + 1);
 	}
 
_
